<?php

namespace DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\PriceCompare\ProductFields\Homebook;

use DOMElement;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\PriceCompare\ProductFields\CustomProductField;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\ProductField;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\ProductFieldXml;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\ProductFieldValue;
use DropshippingExportFreeVendor\WPDesk\Library\DropshippingExport\ProductFields\Value\DescriptionProductFieldValue;
class DescriptionProductField extends CustomProductField implements ProductField, ProductFieldXml
{
    public const TAG_NAME = 'desc';
    private string $field_name;
    private ProductFieldValue $product_value;
    public function __construct(ProductFieldValue $product_value)
    {
        $this->product_value = $product_value;
    }
    public static function get_default_class_value(): string
    {
        return DescriptionProductFieldValue::class;
    }
    public static function is_allowed_to_change(): bool
    {
        return \true;
    }
    public static function get_default_field_name(): string
    {
        return 'description';
    }
    public static function get_default_field_nice_name(): string
    {
        return sprintf(esc_html__('Product description %s', 'dropshipping-export-free'), '(' . self::TAG_NAME . ')');
    }
    public function get_field_name(): string
    {
        $default = self::get_default_field_name();
        return !empty($this->field_name) ? $this->field_name : $default;
    }
    public function set_field_name(string $string)
    {
        $this->field_name = trim($string);
    }
    public function map_xml_value(DOMElement $element): DOMElement
    {
        $root = $element->ownerDocument;
        $value = $this->get_values_as_string($this->product_value);
        if (is_string($value)) {
            $desc = $element->appendChild($root->createElement(self::TAG_NAME));
            $filtered_data = strip_tags(apply_filters('the_content', $value));
            $desc->appendChild($root->createCDATASection($filtered_data));
        }
        return $element;
    }
}
